import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.function.Function;
import java.util.stream.Stream;

import annot.MyAnnot;

class A {
	int i;
	String s;
	
	void f(Integer i, String s) {
//	void f(int i, String s) {
		System.out.printf("ok %d %s%n", i, s);
	}
}

class B extends A {
	List<Integer> li;
}

//@SuppressWarnings({"rawtypes", "xyz"})
@SuppressWarnings(value = {"rawtypes", "xyz"})
@MyAnnot(123)
//@MyAnnot
class T10 {
	@MyAnnot
	@Override
	public String toString() {
		return super.toString();
	}
	
	@Deprecated
//	public static void main(@MyAnnot String[] args) throws ClassNotFoundException, IllegalAccessException, IllegalArgumentException, InvocationTargetException, InstantiationException {
	public static void main(String[] args) throws ClassNotFoundException, IllegalAccessException, IllegalArgumentException, InvocationTargetException, InstantiationException {
		int i = 1;
		Class<?> c = int.class;
//		@MyAnnot Class<?> c = int.class;

		@SuppressWarnings("rawtypes")
		Class c2 = int.class;

		Class<Integer> ic = Integer.class;
		Class<int[]> ic2 = int[].class;
		Class<Class> cc = Class.class;

		System.out.println(cc.getName());
		
		System.out.println(ic2.getName());
		System.out.println(ic2.getCanonicalName());

		Class<? extends Class> class1 = cc.getClass();
		System.out.println(class1);

		Class<?> class3 = Class.forName("java.lang.Class");
		System.out.println(class3);

		int a = 3;
		Map<List<Integer>, Set<String>> m = new HashMap<>();
		
		var a2 = 3;
		var m2 = new HashMap<List<Integer>, Set<String>>();

		System.out.println(m2.getClass());

		Runnable r = () -> {};
		System.out.println(Runnable.class.getName());
		System.out.println(Runnable.class.getCanonicalName());
		System.out.println(r.getClass().getName());
		System.out.println(r.getClass().getCanonicalName());

	
		var v = (Runnable)() -> {};
	
		var v2 = new Runnable() {
			@Override
			public void run() {
			}
			
			void f() {}
		};

		
		Runnable v3 = new Runnable() {
			@Override
			public void run() {
			}
			
			void f() {}
		};
		
		v2.run();
		v2.f();
//		v3.f();

		var i3 = 3;
		var i4 = 3;
		calc(i3, i4);

		for (var e : List.of(1,2,3,4)) {
			
		}
		
		System.out.println(i3);

		System.out.println("----------------------");
	
		Stream.of(A.class.getMethods())
			.map(Method::getName)
			.forEach(System.out::println);
		
		System.out.println("----------------------");
		
		Method[] declaredMethods = A.class.getDeclaredMethods();
		Stream.of(declaredMethods)
		.map(Method::getName)
		.forEach(System.out::println);
		
		System.out.println(Arrays.toString(declaredMethods[0].getParameterTypes()));

		A a123 = new A();
		declaredMethods[0].invoke(a123, 7, "fdsafdsa");
//		declaredMethods[0].invoke(a123, 7);
		
		System.out.println("----------------------");
		
		Stream.of(A.class.getFields())
		.map(Field::getName)
		.forEach(System.out::println);
		
		System.out.println("----------------------");
		
		Field[] declaredFields = A.class.getDeclaredFields();

		Stream.of(declaredFields)
		.map(Field::getName)
		.forEach(System.out::println);

		Class<?> type = declaredFields[0].getType();

		A a234 = A.class.newInstance();

		A.class.getConstructors();

		SuppressWarnings supp = T10.class.getAnnotation(SuppressWarnings.class);
		System.out.println(supp);

		System.out.println(T10.class.getDeclaredAnnotation(MyAnnot.class).value());
	}

	private static void calc(int i3, int i4) throws ClassNotFoundException {
		// TODO Auto-generated method stub

		
		Class.forName("~!@#$%^&*()_+POILKHUHJGFD;';[ ह्ज्वक्ष्ल");
	}
}


class Knowledge {
    private static final Integer ANSWER = 42;
    public String askQuestion(String question) {
        return "The answer to '" + question + "' is: " + ANSWER;
    }
}



class KnowledgeTest {
    public static void testAskQuestion() throws Exception {
        Knowledge knowledge = new Knowledge();
        String answer = knowledge.askQuestion("question?");
        System.out.println(answer);

        setFinalStaticField(Knowledge.class, "ANSWER", 41);
        answer = knowledge.askQuestion("question?");
        System.out.println(answer);
    }

    private static void setFinalStaticField(Class<?> clazz, String fieldName, Object value)
            throws ReflectiveOperationException {
        Field field = clazz.getDeclaredField(fieldName);
        field.setAccessible(true);

        Field modifiers = Field.class.getDeclaredField("modifiers");
        modifiers.setAccessible(true);
        modifiers.setInt(field, field.getModifiers() & ~Modifier.FINAL);
        field.set(null, value);
    }
}
